#!/bin/sh
serverURI=https://www.tuxedocomputers.com/tuxedosysteminfos/systeminfo.php
infoFileName=/repair.log
started=$(date +"%d.%m.%y-%H:%Mh")
ticketnumber=$1
lang=$(echo $LANG | awk -F\_ '{print $1}')

case $lang in
	de)
        text="Wenn Sie eine Ticketnummer haben, können Sie diese hier eintragen und das Logfile an unseren Support schicken.<br>Sollten Sie keine weitere Hilfe benötigen, klicken Sie einfach auf Abbrechen,<br>der Reparaturlauf wird anschließend beendet und sie können ihr System dann rebooten,<br>wenn im Vorfeld keine Fehler aufgetreten sind.<br><br>Um eine Ticketnummer zu erhalten, schreiben Sie uns eine E-Mail an tux@tuxedocomputer.com mit Ihrer Anfrage."
        title="Ticketnummer"
        text1="Keine Ticketnummer angegeben. Beende."
        text2="Logfile erfolgreich übermittelt. Beende...<br><br>In /var/log/repair-live.log des installierten Systems finden Sie zusätzlich das Logfile <br>bis zum Ausstieg aus dem chroot."
        text3="Keine Netzwerkverbindung, das Ssystem muss Online sein, um das logfile zu übertragen."
        text4="Logfile nicht übertragen, Sie finden es zur späteren Auswertung <br>als /var/log/repair-live.log in Ihrem installierten System."
        ;;
    *)
        text="If you have a ticket number, you can enter it here and send the log file to our support.<br>If you do not need any further help, simply click Cancel,<br>the repair run will be terminated and you can then reboot your system,<br>if no errors occurred beforehand.<br>br>To receive a ticket number, send us an email at tux@tuxedocomputer.com with your request."
        title="Ticketnumber"
        text1="No ticket number given. Quitting."
        text2="Logfile successfully transferred. Exit...<br><br>You find the logfile until you exit of the chroot in /var/log/repair-live.log of your installed system."
        text3="No network connection, the system must be online to transfer the logfile."
        text4="The log file was not transferred, you will find it for later evaluation <br>as /var/log/repair-live.log in your installed system."
        ;;
esac

ticketnumber=$(kdialog --inputbox "<font size=4>$text</font>" --title "$title" 2>/dev/null)


if [ -z $ticketnumber ]; then
    kdialog --msgbox "<font size=4>$text1<br>$text4</font>" 2>/dev/null
    exit 1
fi


printf "\n"
echo 'Ticketnummer: ' $ticketnumber | tee -a $infoFileName
echo 'upload-log.sh started at' $started | tee -a $infoFileName
printf "\n\n" | tee -a $infoFileName

printf "repair run\n\n" >> $infoFileName
cat /repair-live.log >> $infoFileName

# Rename files
cp $infoFileName /repairlog-$ticketnumber.txt

zip -9 repairlog-$ticketnumber.zip /*-$ticketnumber.txt

# Re-Check Internet connection before sending
printf "\n"
printf "Überprüfe Internetverbindung... / Checking Internet connection... \n"
wget -q --spider https://tuxedocomputers.com
if [ $? -eq 0 ]; then
    printf "\e[32mOnline\e[0m\n"
    printf "\e[37m\e[0m\n"
else
    printf "\e[31mOffline! Um die Ergebnisse übermitteln zu können ist eine Internetverbindung erforderlich! / Offline! An Internet connection is required to transmit the results! \e[1m\n"
    printf "\e[37m\e[0m\n"
    kdialog --msgbox "$text3" 2>/dev/null
    exit 1
fi

curl -F "file=@repairlog-$ticketnumber.zip" $serverURI?ticketnumber=$ticketnumber
if [ $? -eq 0 ]; then
    kdialog --msgbox "$text2" 2>/dev/null
else
    kdialog --msgbox "$text4" 2>/dev/null
fi
rm /repairlog-$ticketnumber.zip /*-$ticketnumber.txt /repair.log
exit 0;
